<id>
Distilled Email Domains
</id>

<version>
beta 4
</version>

<mod info>
This mod allows admins to designate which email domain a person can register with and also allows the admin to choose to block certain domains from registering. Gmods and admins are immune.

If the admin allows only certain domains, at registration, a new user can add their userid and then select which domain their email is located from a dropdown menu on the registration page.  If they enter a full email address in the field, an error will occur.  If a new user tries to change their email address in their profile, they will only be able to select the domains that the admin allows. 

If an admin blocks certain domains, an error will occur if a user tries to register with any domain that is blocked.  If they register and then try to change it to a "bad" domain in their profile, they will get an error there too.

Current members will still be able to change their email as they please unless it is a blocked domain.  Once they choose an email from an allowed domain, they will always have to choose from the allowed domain list. An admin can force their users to a certain domain by setting a date they must change by and then deleting their account if they had not changed.

With this and having email password or account activation enabled and having a new password emailed everytime a email address is changed, an admin can effectively distill the domains available.

Installation
---------------------
1. Uninstall any previous version
2. Install new version and upload files (Admin.pl, AdminSubList.pl, Register.pl, Profile.pl & AdminIndex.pl) to their appropiate directory in ASCII.
3. Upload the language file to the language folder (chose your translation if available) in ASCII.
4. Upload the Distilled_Email_Domains.txt file to the Variable directory in ASCII.


History
-----------
beta 1 - Initial release
beta 2 - Changed mod name, added domain blocking, added distillation from profile screen
beta 3 - Fixed mod file error
beta 4 - Made domain matching more specific


Comments
--------------
- This mod and idea was originally by Carsten for YaBB 1.3. This is a new coding of this mod for YaBB2 and includes new features.  This is not an update.
- Admins really can define the suffix of an email addres (i.e. ".schoolname.somethingelse@lgfl.net") and is not limited to just domain names.
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	### Distilled Email Domains mod ###
	LoadLanguage("Distilled_Email_Domains");
	$Distilled_Email_Domains = "distillededomains|$Distilled_Email_Domains_txt{'2'}|$Distilled_Email_Domains_txt{'5'}|";
	push (@boardmod_mods, "$Distilled_Email_Domains");
	### Distilled Email Domains mod end ###
</add before>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
}

1;
</search for>

<replace>
}

### Distilled Email Domains mod ###
sub EDomainsDistilled {
	&is_admin_or_gmod;
	LoadLanguage("Distilled_Email_Domains");
	require "$vardir/Distilled_Email_Domains.txt";
	if ($adomains || $bdomains){$adomains =~ s~,~\n~g; $bdomains =~ s~,~\n~g;}
	$yymain .= qq~
<form action="$adminurl?action=distillededomains2" method="post">
 <div class="bordercolor" style="padding: 0px; width: 50%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       	<td align="left" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" /> <b>$Distilled_Email_Domains_txt{'1'} - $Distilled_Email_Domains_txt{'4'}</b></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg"><span class="small">$Distilled_Email_Domains_txt{'3'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2"><br /><textarea cols="60" rows="10" name="adomains" style="width: 95%">$adomains</textarea><br /><br /></td>
     </tr>
   </table>
 </div><br />
  <div class="bordercolor" style="padding: 0px; width: 50%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       	<td align="left" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" /> <b>$Distilled_Email_Domains_txt{'1'} - $Distilled_Email_Domains_txt{'6'}</b></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg"><span class="small">$Distilled_Email_Domains_txt{'7'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2"><br /><textarea cols="60" rows="10" name="bdomains" style="width: 95%">$bdomains</textarea><br /><br /></td>
     </tr>
   </table>
 </div><br />
   <div class="bordercolor" style="padding: 0px; width: 50%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
     	<td align="center" class="catbg"><input type="submit" value="$admin_txt{'10'}" /></td>
     </tr>
   </table>
 </div>
</form>~;
	$yymain
	&AdminTemplate;
}

sub EDomainsDistilled2 {
	&is_admin_or_gmod;
	@domains = ($FORM{'adomains'},$FORM{'bdomains'});
	foreach (@domains){
		$_ =~ s~\r~~g;
		$_ =~ s~\n~,~g;
		$_ =~ s~\s+~~g;
		$_ =~ s~(^,+|,+$)~~g;
		$_ =~ s~,+~,~g;
		$_ =~ s~\@~\\@~g;
	}
	#admin_fatal_error("$domains[0]<br>$domains[1]");
	fopen(FILE, ">$vardir/Distilled_Email_Domains.txt");
	print FILE qq~\$adomains = "$domains[0]";\n~;
	print FILE qq~\$bdomains = "$domains[1]";\n~;
	print FILE qq~1;~;
	fclose(FILE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
### Distilled Email Domains mod ###
}

1;
</replace>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'distillededomains',"Admin.pl&EDomainsDistilled", ### Distilled Email Domains mod ###
'distillededomains2',"Admin.pl&EDomainsDistilled2", ### Distilled Email Domains mod ###
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$distilled_email_domains = "Distilled Email Domains YaBB2|astro-pilot|This mod allows admins to designate which email domain a person can register with and also allows the admin to choose to block certain domains from registering. With this and having email password or account activation enabled and having a new password emailed everytime a email address is changed, an admin can effectively distill the domains available. Gmods and admins are immune.|beta 4|11/10/05";
	push (@installed_mods, "$distilled_email_domains");
</add before>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	if (!$iamguest) { &fatal_error("$register_txt{'2'}"); }
</search for>

<add after>
	### Distilled Email Domains mod ###
	require "$vardir/Distilled_Email_Domains.txt";
	if ($adomains){
		@domains = split (/\,/, $adomains);
		$aedomains = qq~<table border="0" width="100%" cellspacing="0" cellpadding="0"><tr><td><input type="text" maxlength="30" name="email" value="$tmpregemail" size="15" /></td><td><select name="domain">~;
		foreach (@domains){$aedomains .= ($_ =~ m/\@/) ? qq~<option value="$_">$_</option>~ : qq~<option value="\@$_">&#64;$_</option>~;}
		$aedomains .= qq~</select></td></tr></table>~;
	}
	else {$aedomains .= qq~<input type="text" maxlength="60" name="email" value="$tmpregemail" size="45" />~;}
	### Distilled Email Domains mod end ###
</add after>

<search for>
	    <input type="text" maxlength="60" name="email" value="$tmpregemail" size="45" />
</search for>

<replace>
	    $aedomains <!-- ### Distilled Email Domains mod ### -->
</replace>

<search for>
		<input type="text" name="email" size="50" />
</search for>

<replace>
		$aedomains <!-- ### Distilled Email Domains mod ### -->
</replace>

<search for>
	$member{'username'} =~ s/\s/_/g;
</search for>

<add after>
	### Distilled Email Domains mod ###
	if ($member{'domain'}) {$member{'email'} = qq($member{'email'}$member{'domain'});} 
	
	require "$vardir/Distilled_Email_Domains.txt";
	if ($bdomains && !$adomains){
		LoadLanguage("Distilled_Email_Domains");
		@domains = split (/\,/, $bdomains);
		foreach (@domains) {
			if ($_ !~ /\@/) {$_ = "\@$_";}
			elsif ($_ !~ /^./) {$_ = ".$_";}
			&fatal_error("$Distilled_Email_Domains_txt{'8'} $_.") if $member{'email'} =~ m/$_/i;
		}
	}
	### Distilled Email Domains mod end ###
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$yymain .= qq~
<form action="$scripturl?action=profileContacts2;username=$INFO{'username'};sid=$INFO{'sid'}" method="post" name="creator">
<table cellspacing="1" cellpadding="4" width="100%" align="center" class="bordercolor" border="0">
</search for>

<add before>
	
	### Distilled Email Domains mod ###
	require "$vardir/Distilled_Email_Domains.txt";
	if ($adomains && !$iamadmin && !$iamgmod){
		@domains = split (/\,/, $adomains);
		$aedomains = qq~<select name="domain">~;
		$emailuserid = ${$uid.$user}{'email'};
		foreach (@domains){
			if (${$uid.$user}{'email'} =~ m/$_/) {
				$aedomains .= ($_ =~ m/\@/) ? qq~<option value="$_" selected>$_</option>~ : qq~<option value="\@$_" selected>&#64;$_</option>~;
				$founddomain = 1;
				$emailuserid =~ s~\@$_~~;
			}
			else {$aedomains .= ($_ =~ m/\@/) ? qq~<option value="$_">$_</option>~ : qq~<option value="\@$_">&#64;$_</option>~;}
		}
		$aedomains .= qq~</select><br />~;
	}
	### Distilled Email Domains mod end ###

</add before>

<search for>
    <td align="left"><input type="text" maxlength="60" name="email" size="40" value="${$uid.$user}{'email'}" /></td>
  </tr>~;
	if ($allow_hide_email) {
</search for>

<replace>
~;
	### Distilled Email Domains mod ###	
	if (!$founddomain || $iamadmin || $iamgmod) {$yymain .= qq~<td align="left"><input type="text" maxlength="50" name="email" size="40" value="${$uid.$user}{'email'}" /></td></tr>~;}
	else {$yymain .= qq~<td align="left"><input type="text" maxlength="30" name="email" size="15" value="$emailuserid" />$aedomains</td></tr>~;}
	### Distilled Email Domains mod end ###

	if ($allow_hide_email) {
</replace>

<search for>
		${$uid.$user}{'password'} = &encode_password($member{'passwrd1'});
		$newpassemail = 1;
	}
</search for>

<add after>
	### Distilled Email Domains mod ###
	if ($member{'domain'}) {
		$member{'email'} = qq($member{'email'}$member{'domain'});
		$FORM{'email'} = $member{'email'};
	} 
	
	require "$vardir/Distilled_Email_Domains.txt";
	if ($bdomains && !$member{'domain'} && !$iamadmin && !$iamgmod){
		LoadLanguage("Distilled_Email_Domains");
		@domains = split (/\,/, $bdomains);
		foreach (@domains) {
			if ($_ !~ /\@/) {$_ = "\@$_";}
			elsif ($_ !~ /^./) {$_ = ".$_";}
			&fatal_error("$Distilled_Email_Domains_txt{'8'} $_.") if $member{'email'} =~ m/$_/i;
		}
	}
	### Distilled Email Domains mod end ###

</add after>